Open Babel: OBAtomClassData Class Reference

Public Member Functions | Protected Attributes

# OBAtomClassData Class Reference

Handle atom classes in reaction SMILES/SMIRKS. More...

`#include <openbabel/atomclass.h>`

Inheritance diagram for OBAtomClassData:

List of all members.

## Public Member Functions
| OBAtomClassData ()
virtual OBGenericData * | Clone (OBBase *) const
void | Clear ()
void | Add (int indx, int cl)
bool | HasClass (int indx) const
int | GetClass (int indx) const
std::string | GetClassString (int indx)
int | size ()
void | SetAttribute (const std::string &v)
void | SetOrigin (const DataOrigin s)
virtual const std::string & | GetAttribute () const
unsigned int | GetDataType () const
virtual const std::string & | GetValue () const
virtual DataOrigin | GetOrigin () const
## Protected Attributes
std::map< int, int > | _map
std::string | _attr
unsigned int | _type
DataOrigin | _source

## Detailed Description

Handle atom classes in reaction SMILES/SMIRKS.

Since:
  version 2.2

Class for attaching to OBMol to hold the info from SMILES like [C:2] Useful for reaction SMILES (SMIRKS). It influences the atom id attribute in CML. Not all atoms need have an atom class. The atom class can be any positive or negative integer.

## Constructor & Destructor Documentation

OBAtomClassData | ( | ) | `[inline]`

## Member Function Documentation

virtual OBGenericData* Clone | ( | OBBase * | ) | const`[inline, virtual]`

Reimplemented from OBGenericData.

void Clear | ( | void | ) | `[inline]`

Erase contents.

void Add | ( | int | indx,
|  | int | cl
| ) |  | `[inline]`

Add an individual value.

bool HasClass | ( | int | indx ) | const`[inline]`

Returns:
  true if there is an entry for atom index

int GetClass | ( | int | indx ) | const`[inline]`

Returns:
  value of class index (Test with HasClass first)

std::string GetClassString | ( | int | indx ) | `[inline]`

If there is an entry for indx, return ":n" where n is the atomclass value; otherwise return an empty string

int size | ( | ) | `[inline]`

void SetAttribute | ( | const std::string & | v ) | `[inline, inherited]`

Set the attribute (key), which can be used to retrieve this data.

Referenced by OBGastChrg::AssignPartialCharges(), OBMol::DoTransformations(), OBMol::FindLSSR(), OBMol::FindSSSR(), OBForceField::GetAtomTypes(), OBMol::GetFormula(), OBMol::GetLSSR(), OBForceField::GetPartialCharges(), OBMol::GetSSSR(), OBDescriptor::PredictAndSave(), and OBMol::SetFormula().

void SetOrigin | ( | const DataOrigin | s ) | `[inline, inherited]`

Set the origin of this data, which can be used to filter the data.

Referenced by OBGastChrg::AssignPartialCharges(), OpenBabel::CalcSignedVolume(), OBMol::FindAngles(), OBMol::FindLSSR(), OBMol::FindSSSR(), OBMol::FindTorsions(), OBMol::GetFormula(), OBMol::GetLSSR(), OBMol::GetSSSR(), OBDescriptor::PredictAndSave(), and OBMol::SetFormula().

virtual const std::string& GetAttribute | ( | ) | const`[inline, virtual, inherited]`

Returns:
  The attribute (key), which can be used to retrieve this data

Referenced by OBMoleculeFormat::MakeCombinedMolecule().

unsigned int GetDataType | ( | ) | const`[inline, inherited]`

Returns:
  the data type for this object as defined in OBGenericDataType

virtual const std::string& GetValue | ( | ) | const`[inline, virtual, inherited]`

Base class returns a default value (the attribute type) but should never be called.

Reimplemented in OBCommentData, and OBPairData.

Referenced by OBDepict::DrawMolecule(), OBDescriptor::FilterCompare(), and OBDescriptor::GetValues().

virtual DataOrigin GetOrigin | ( | ) | const`[inline, virtual, inherited]`

## Member Data Documentation

std::map<int,int> _map`[protected]`

std::string _attr`[protected, inherited]`

attribute tag (e.g., "UnitCell", "Comment" or "Author")

Referenced by OBRotamerList::Clone(), and OBNasaThermoData::OBNasaThermoData().

unsigned int _type`[protected, inherited]`

attribute type -- declared for each subclass

Referenced by OBRotamerList::Clone(), and OBNasaThermoData::OBNasaThermoData().

DataOrigin _source`[protected, inherited]`

source of data for accounting

Referenced by OBChiralData::operator=(), OBTorsionData::operator=(), OBAngleData::operator=(), OBConformerData::operator=(), and OBSymmetryData::operator=().

The documentation for this class was generated from the following file:

- atomclass.h

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines